/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};
var isInit = false
RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');

document.addEventListener("selectionchange", function() {
    if(!isInit&&(document.innerHTML == "undefined" || document.innerHTML == null || document.innerHTML == "")){
        isInit = true
        //初始化 java代码直接设置不行 必须在此时选中后
        console.log("初始化-默认style")
        /*document.execCommand("fontSize", false, 4);
        RE.fixFontSize()*/
    }else{
//        RE.backuprange();
    }
    RE.backuprange();
  }
 );

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
    RE.callback();
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    var result = document.execCommand('undo', false, null);
    // RE.enabledEditingItems();
    return result;
}

RE.redo = function() {
    document.execCommand('redo', false, null);
    // RE.enabledEditingItems();
    return result;
}

RE.queryCommandEnabled = function(command) {
    return document.queryCommandEnabled(command);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}


RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.insertImage = function(url, alt, append) {
    var html = '<img src="' + url + '" alt="' + alt + '" />' + append;
    RE.insertHTML(html);
    RE.editor.scrollIntoView(false)
}
//&nbsp; 让其可以继续进去编辑模式
RE.insertVideo = function(url,custom,posterUrl) {
    var html = '&nbsp;<video controls="controls" poster="' +posterUrl+ '" src="' + url + '" ' + custom +'></video>&nbsp;<br></br>';
    RE.insertHTML(html);
    RE.editor.scrollIntoView(false)
}

RE.insertAudio = function(url,custom) {
    var html = '&nbsp;<audio src="' + url + '" ' + custom +'></audio>&nbsp;<br></br>';
    RE.insertHTML(html);
    RE.editor.scrollIntoView(false)
}



RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    console.log("backuprange");
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
    RE.callback();
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.enabledEditingItems = function(e) {

    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_UP = 38, KEY_RIGHT = 39, KEY_DOWN = 40, KEY_BACK_SPACE = 8, KEY_ENTER = 13;
    if (e.which == KEY_LEFT
        || e.which == KEY_UP
        || e.which == KEY_RIGHT
        || e.which == KEY_DOWN
        || e.which == KEY_BACK_SPACE
        || e.which == KEY_ENTER) {
        RE.enabledEditingItems(e);
    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);

// 监听剪贴板, 参考:http://www.mamicode.com/info-detail-2831291.html
//RE.editor.addEventListener('paste', function(e)
//{
//    console.log("paste listener")
//    e.preventDefault();
//    // e.stopPropagation();
//
//    var clip  = e.clipboardData || window.clipboardData;
//    if(clip)
//    {
//        var txt = clip.getData('text');
//        var txt_plain = clip.getData('text/plain');
//
//        console.log("txt:" + txt)
//        console.log("txt_plain:" + txt_plain)
//
//        if(txt)
//        {
//            console.log("call RE insertHTML txt")
//            RE.insertHTML(txt);
//        }
//        else if(txt_plain)
//        {
//            console.log("call RE insertHTML txt_plain")
//            RE.insertHTML(txt);
//        }
//        else
//        {
//            console.log("没取到剪贴板内容")
//        }
//    }
//    else
//    {
//        console.log("剪贴板获取失败")
//    }
//});

//RE.editor.addEventListener('paste',  function(e) {
//
//    console.log("paste listener")
//    // 阻止默认的复制事件
//    e.preventDefault()
//
//    // 获取复制的文本
//    var txt = e.clipboardData.getData('text/plain')
//    console.log("#1")
//    // 获取页面文本选区
//    var range = window.getSelection().getRangeAt(0)
//    console.log("#2")
//    // 删除默认选中文本
//    range.deleteContents()
//    console.log("#3")
//    // 创建一个文本节点，用于替换选区文本
//    var pasteTxt = document.createTextNode(txt)
//    console.log("#4")
//    // 插入文本节点
//    range.insertNode(pasteTxt)
//    console.log("#5")
//    // 将焦点移动到复制文本结尾
//    range.collapse(true)
//    console.log("#6")
//});

RE.fixFontSize = function()
{
    var font = document.querySelectorAll('font')
    if(!font)
    {
        return
    }
    font.forEach(function(item)
    {
        if (item.getAttribute('size') == '1')
        {
            item.style.fontSize='13px';
            console.log("fixFontSize 13px");
        }
        else if (item.getAttribute('size') == '2')
        {
            item.style.fontSize='15px';
            console.log("fixFontSize 15px");
        }
        else if (item.getAttribute('size') == '3')
        {
            item.style.fontSize='17px';
            console.log("fixFontSize 17px");
        }
        else if (item.getAttribute('size') == '4')
        {
            item.style.fontSize='19px';
            console.log("fixFontSize 19px");
        }
        else
        {
            console.log("fixFontSize null");
        }
        item.removeAttribute("size")
        console.log("fixFontSize End");
    });
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}


//获取当前光标所在内包含的所有样式
RE.getSelectedNode = function() {
    var node,selection;
    if (window.getSelection) {
        selection = getSelection();
        node = selection.anchorNode;
    }
    if (!node && document.selection) {
        selection = document.selection
        var range = selection.getRangeAt ? selection.getRangeAt(0) : selection.createRange();
        node = range.commonAncestorContainer ? range.commonAncestorContainer :
        range.parentElement ? range.parentElement() : range.item(0);
    }
    if (node) {
        var item =  (node.nodeName == "#text" ? node.parentNode : node);
         console.log("innerHTML:"+item.innerHTML);
         console.log("font-size:"+item.style["font-size"]);
         console.log("color:"+item.getAttribute("color"));
         console.log("queryCommandState1 bold:"+document.queryCommandState('bold'));

         console.log("src:"+item.getAttribute("src"));
         console.log(item.style["font-size"]+"|"+item.getAttribute("color")+"|"+document.queryCommandState('bold'))

    }
}